@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

set /A failure_count=0
SETLOCAL
:do_clean_factory_params
    call :view_clean_fac_param_ver

    set securestate=
    for /f "tokens=2 delims=: " %%i in ('%fastboot% -s %serial_number% getvar securestate 2^>^&1^| findstr securestate') do (set securestate=%%i)

    call :view_clean_fac_device_securestate "%securestate%"

    if "%securestate%" NEQ "engineering" (
        call :view_clean_fac_device_is_not_eng !serial_number!
        goto :end_check
    )

    REM =============================================================
    REM Check cmdl
    set _resp=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem config cmdl 2^>^&1 ^| %%sed%% "s@(bootloader)@@g;/OKAY \[/d;/^[f^|F]inished/d;/UTAG name/d;/value>/d" ^| %%awk%% "{printf \"%%s\",$0}" ^| %%sed%% "s@<descr.*@@g";`) do (set _resp=%%i)

    call :view_clean_fac_device_cmdl "%_resp%"

    if "%_resp%" NEQ "" (
        call :view_clean_fac_clear_cmdl
        !fastboot! -s !serial_number! oem config cmdl ""
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_clean_fac_clear_cmdl_failed
        )
    )

    REM =============================================================

    REM =============================================================
    REM Check power off mode charge
    set _resp=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem off-mode-charge 2^>^&1 ^| findstr "off_mode_charge" ^| %%awk%% -F"off_mode_charge " "{print $2}"`) do (
        set _resp=%%i
    )

    call :view_clean_fac_device_offmodecharge "%_resp%"

    if "%resp%" == "disabled" (
        call :view_clean_fac_enable_offmodecharge
        !fastboot! -s !serial_number! oem off-mode-charge enable
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_clean_fac_enable_offmodecharge_failed
        )
    )
    REM =============================================================

    REM =============================================================
    REM Check ramdump status
    set _resp=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem ramdump status 2^>^&1 ^| findstr "RAM dump" ^| %%awk%% -F"RAM dump " "{print $2}"`) do (
        set _resp=%%i
    )

    call :view_clean_fac_device_ramdump "%_resp%"

    if "%_resp%" == "enabled" (
        call :view_clean_fac_disable_ramdump
        !fastboot! -s !serial_number! oem ramdump disable
        !fastboot! -s !serial_number! oem ramdump disable
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_clean_fac_disable_ramdump_failed
        )
    )
    REM =============================================================

    REM =============================================================
    REM Check memtest mode
    set _resp=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem config memtest_mode 2^>^&1 ^| %%sed%% "s@(bootloader)@@g;/OKAY \[/d;/^[f^|F]inished/d;/UTAG name/d;/value>/d" ^| %%awk%% "{printf \"%%s\",$0}" ^| %%sed%% "s@<descr.*@@g";`) do (set _resp=%%i)

    call :view_clean_fac_device_memtestmode "%_resp%"

    if "%_resp%" NEQ "" (
        call :view_clean_fac_disable_memtestmode
        !fastboot! -s !serial_number! oem config memtest_mode ""
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_clean_fac_disable_memtestmode_failed
        )
    )
    REM =============================================================

    REM =============================================================
    REM Check console param
    set _resp=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem config console 2^>^&1 ^| %%sed%% "s@(bootloader)@@g;/OKAY \[/d;/^[f^|F]inished/d;/UTAG name/d;/value>/d" ^| %%awk%% "{printf \"%%s\",$0}" ^| %%sed%% "s@<descr.*@@g";`) do (set _resp=%%i)

    call :view_clean_fac_device_console "%_resp%"

    if "%_resp%" NEQ "" (
        call :view_clean_fac_clear_console
        !fastboot! -s !serial_number! oem config console ""
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_clean_fac_clear_console_failed
        )
    )
    REM =============================================================

    :end_check
    ENDLOCAL
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_clean_fac_param_ver
    echo.
    echo clean-factory-param v1.0.0-2023-09-09
exit /b 0
::
:view_clean_fac_device_securestate
    echo.
    echo ǰ豸ȫ״̬[%~1]
exit /b 0
::
:view_clean_fac_device_is_not_eng
    echo.
    echo 豸 [%1] δڹģʽ顣
exit /b 0
::
:view_clean_fac_device_cmdl
    echo.
    echo ǰ cmdl [%~1]
exit /b 0
::
:view_clean_fac_get_cmdl_failed
    echo WARNING: Get the cmdl failed
exit /b 0
::
:view_clean_fac_clear_cmdl
    echo.
    echo ==^> ں...
exit /b 0
::
:view_clean_fac_clear_cmdl_failed
    echo [] ںʧܣ
exit /b 0
::
:view_clean_fac_device_offmodecharge
    echo ǰ off-mode-charge ״̬[%~1]
exit /b 0
::
:view_clean_fac_enable_offmodecharge
    echo.
    echo ==^>  off-mode-charge ģʽ...
exit /b 0
::
:view_clean_fac_enable_offmodecharge_failed
    echo []  off-mode-charge ʧܣ
exit /b 0
::
:view_clean_fac_device_ramdump
    echo ǰ ramdump ״̬[%~1]
exit /b 0
::
:view_clean_fac_disable_ramdump
    echo.
    echo ==^>  ramdump...
exit /b 0
::
:view_clean_fac_disable_ramdump_failed
    echo []  ramdump ʧܣ
exit /b 0
::
:view_clean_fac_device_memtestmode
    echo ǰ memtest_mode ״̬[%~1]
exit /b 0
::
:view_clean_fac_disable_memtestmode
    echo ==^>  memtest ģʽ...
exit /b 0
::
:view_clean_fac_disable_memtestmode_failed
    echo []  ramdump ʧܣ
exit /b 0
::
:view_clean_fac_device_console
    echo ǰ console [%~1]
exit /b 0
::
:view_clean_fac_clear_console
    echo ==^>  console...
exit /b 0
::
:view_clean_fac_clear_console_failed
    echo []  console ʧܣ
exit /b 0
