@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:do_flash_bl_mtk
    REM return: 0 or 1

    REM GPT part
    set img_file=
    set img_name=PGPT
    set pt_name=gpt
    set /A A=0

    if exist gpt.bin set /A A+=1
    if exist diskmap.pit set /A A+=1
    if exist PGPT (
        set /A A+=1
        set img_file=PGPT
    )

    if %A% GTR 1 (
        call :view_flash_image_duplicate_error2 !img_name!
        exit /b 1
    )
    if %A% == 1 (
        if "!img_file!" == "" (
            call :view_flash_image_format_error !img_name!
            exit /b 1
        )

        call :view_flash_image_title !img_name!
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            call :view_flash_image_fatal_failed !img_name!
            exit /b 1
        )
    ) else (
        call :view_flash_image_not_exist_w1 !img_name!
    )

    REM preloader part
    set img_file=
    set img_name=PRELOADER
    set pt_name=preloader
    set /A A=0

    if exist motoboot.img set /A A+=1
    if exist bootloader.img set /A A+=1
    if exist bootloader.bin set /A A+=1
    if exist preloader.bin (
        set img_file=preloader.bin
        set /A A+=1
    )
    if exist preloader.img (
        set img_file=preloader.img
        set /A A+=1
    )
    if %A% GTR 1 (
        call :view_flash_image_duplicate_error2 !img_name!
        exit /b 1
    )
    if %A% == 0 (
        call :view_flash_image_not_exist_e !img_name!
        exit /b 1
    )
    if %A% == 1 (
        if "!img_file!" == "" (
            call :view_flash_image_format_error !img_name!
            exit /b 1
        )

        call :view_flash_image_title !img_name!
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            call :view_flash_image_fatal_failed !img_name!
            exit /b 1
        )
    )

    if "%FLAG_DEVICE_HAS_LK%" == "1" (
        set img_file=lk.img
        set img_name=LK
        set pt_name=lk

        if exist "!img_file!" (
            set pt_list=_a _b
            for %%a in (!pt_list!) do (
                call :view_flash_image_title !pt_name!%%a
                !fastboot! -s !serial_number! flash !pt_name!%%a !img_file!
                if !errorlevel! == 1 (
                    call :view_flash_image_fatal_failed %%a
                    exit /b 1
                )
            )
        ) else (
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    if "%FLAG_DEVICE_HAS_TEE%" == "1" (
        set img_file=tee.img
        set img_name=TEE
        set pt_name=tee

        if exist "!img_file!" (
            set pt_list=_a _b
            for %%a in (!pt_list!) do (
                call :view_flash_image_title !pt_name!%%a
                !fastboot! -s !serial_number! flash !pt_name!%%a !img_file!
                if !errorlevel! == 1 (
                    call :view_flash_image_fatal_failed %%a
                    exit /b 1
                )
            )
        ) else (
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    if "%FLAG_DEVICE_HAS_MCUPM%" == "1" (
        set img_file=mcupm.img
        set img_name=MCUPM
        set pt_name=mcupm

        if exist "!img_file!" (
            set pt_list=_a _b
            for %%a in (!pt_list!) do (
                call :view_flash_image_title !pt_name!%%a
                !fastboot! -s !serial_number! flash !pt_name!%%a !img_file!
                if !errorlevel! == 1 (
                    call :view_flash_image_fatal_failed %%a
                    exit /b 1
                )
            )
        ) else (
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    if "%FLAG_DEVICE_HAS_PI_IMG%" == "1" (
        set img_file=pi_img.img
        set img_name=PI_IMG
        set pt_name=pi_img

        if exist "!img_file!" (
            set pt_list=_a _b
            for %%a in (!pt_list!) do (
                call :view_flash_image_title !pt_name!%%a
                !fastboot! -s !serial_number! flash !pt_name!%%a !img_file!
                if !errorlevel! == 1 (
                    call :view_flash_image_fatal_failed %%a
                    exit /b 1
                )
            )
        ) else (
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    if "%FLAG_DEVICE_HAS_SSPM%" == "1" (
        set img_file=sspm.img
        set img_name=SSPM
        set pt_name=sspm

        if exist "!img_file!" (
            set pt_list=_a _b
            for %%a in (!pt_list!) do (
                call :view_flash_image_title !pt_name!%%a
                !fastboot! -s !serial_number! flash !pt_name!%%a !img_file!
                if !errorlevel! == 1 (
                    call :view_flash_image_fatal_failed %%a
                    exit /b 1
                )
            )
        ) else (
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    if "%FLAG_DEVICE_HAS_DTBO%" == "1" (
        set img_file=dtbo.img
        set img_name=DTBO
        set pt_name=dtbo

        if exist "!img_file!" (
            set pt_list=_a _b
            for %%a in (!pt_list!) do (
                call :view_flash_image_title !pt_name!%%a
                !fastboot! -s !serial_number! flash !pt_name!%%a !img_file!
                if !errorlevel! == 1 (
                    call :view_flash_image_fatal_failed %%a
                    exit /b 1
                )
            )
        ) else (
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    if "%FLAG_DEVICE_HAS_SPMFW%" == "1" (
        set img_file=spmfw.img
        set img_name=SPMFW
        set pt_name=spmfw

        if exist "!img_file!" (
            set pt_list=_a _b
            for %%a in (!pt_list!) do (
                call :view_flash_image_title !pt_name!%%a
                !fastboot! -s !serial_number! flash !pt_name!%%a !img_file!
                if !errorlevel! == 1 (
                    call :view_flash_image_fatal_failed %%a
                    exit /b 1
                )
            )
        ) else (
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    if "%FLAG_DEVICE_HAS_SCP%" == "1" (
        set img_file=scp.img
        set img_name=SCP
        set pt_name=scp

        if exist "!img_file!" (
            set pt_list=_a _b
            for %%a in (!pt_list!) do (
                call :view_flash_image_title !pt_name!%%a
                !fastboot! -s !serial_number! flash !pt_name!%%a !img_file!
                if !errorlevel! == 1 (
                    call :view_flash_image_fatal_failed %%a
                    exit /b 1
                )
            )
        ) else (
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    if "%FLAG_DEVICE_HAS_DPM%" == "1" (
        set img_file=dpm.img
        set img_name=DPM
        set pt_name=dpm

        if exist "!img_file!" (
            set pt_list=_a _b
            for %%a in (!pt_list!) do (
                call :view_flash_image_title !pt_name!%%a
                !fastboot! -s !serial_number! flash !pt_name!%%a !img_file!
                if !errorlevel! == 1 (
                    call :view_flash_image_fatal_failed %%a
                    exit /b 1
                )
            )
        ) else (
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    if "%FLAG_DEVICE_HAS_GZ%" == "1" (
        set img_file=gz.img
        set img_name=GenieZone
        set pt_name=gz

        if exist "!img_file!" (
            set pt_list=_a _b
            for %%a in (!pt_list!) do (
                call :view_flash_image_title !pt_name!%%a
                !fastboot! -s !serial_number! flash !pt_name!%%a !img_file!
                if !errorlevel! == 1 (
                    call :view_flash_image_fatal_failed %%a
                    exit /b 1
                )
            )
        ) else (
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    if "%FLAG_DEVICE_HAS_VCP%" == "1" (
        set img_file=vcp.img
        set img_name=VCP
        set pt_name=vcp

        if exist "!img_file!" (
            set pt_list=_a _b
            for %%a in (!pt_list!) do (
                call :view_flash_image_title !pt_name!%%a
                !fastboot! -s !serial_number! flash !pt_name!%%a !img_file!
                if !errorlevel! == 1 (
                    call :view_flash_image_fatal_failed %%a
                    exit /b 1
                )
            )
        ) else (
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    if "%FLAG_DEVICE_HAS_GPUEB%" == "1" (
        set img_file=gpueb.img
        set img_name=GPUEB
        set pt_name=gpueb

        if exist "!img_file!" (
            set pt_list=_a _b
            for %%a in (!pt_list!) do (
                call :view_flash_image_title !pt_name!%%a
                !fastboot! -s !serial_number! flash !pt_name!%%a !img_file!
                if !errorlevel! == 1 (
                    call :view_flash_image_fatal_failed %%a
                    exit /b 1
                )
            )
        ) else (
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    if "%FLAG_DEVICE_HAS_EFUSE_BACKUP%" == "1" (
        set img_file=efuse.img
        set img_name=efuseBackup
        set pt_name=efuseBackup

        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_fatal_failed !img_name!
                exit /b 1
            )
        ) else (
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    if "%FLAG_DEVICE_HAS_EFUSE%" == "1" (
        if "!FLAG_DEVICE_HAS_EFUSE_BACKUP!" == "1" ( goto :skip_flash_efuse)
        set img_file=efuse.img
        set img_name=EFUSE
        set pt_name=efuse

        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_fatal_failed !img_name!
                exit /b 1
            )
        ) else (
            call :view_flash_image_not_exist_w !img_name!
        )
    )
    :skip_flash_efuse

exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_flash_image_duplicate_error2
    color fc
    echo.
    echo [ش] ͵ %1 ͬʱڡȻǲԵģ飡
exit /b 0
::
:view_flash_image_not_exist_e
    color fc
    echo.
    echo [ش] %1 񲻴ڡȻǲԵģ̼ļλã
exit /b 0
::
:view_flash_image_not_exist_w
    echo.
    echo [] %1 񲻴ڣ豸и÷ˢ...
exit /b 0
::
:view_flash_image_not_exist_w1
    echo.
    echo [] %1 񲻴ڡˢ...
exit /b 0
::
:view_flash_image_title
    echo.
    echo ------ ˢ %1  ------
exit /b 0
::
:view_flash_image_fatal_failed
    color fc
    echo ------------------------------
    echo [ش] fastboot ˢ %1 ʧܣ
    echo ------------------------------
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
