@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:get_partition_table
    REM vers
    set FLAG_DEVICE_AB_SLOT=0
    set FLAG_DEVICE_GPT_DAMAGED=0
    set FLAG_DEVICE_USE_MOT_OEM_FASTBOOT=0
    set SLOT_SUFFIX=

    REM is device support A/B partition?
    set device_slot_count=0
    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% getvar slot-count 2^>^&1 ^| %%awk%% "/slot-count: /{printf $2}"`) do (
        set device_slot_count=%%X
    )

    if "%device_slot_count%" == "" (
        echo.
        echo [Debug] Device slot info is Unknown.
        set FLAG_DEVICE_AB_SLOT=0
    )

    if "%device_slot_count%" == "2" (
        echo.
        echo [Debug] Device [!serial_number!] has slot A/B partition.
        set FLAG_DEVICE_AB_SLOT=1
    ) else (
        echo.
        echo [Debug] Device [!serial_number!] does not have slot A/B partition.
        set FLAG_DEVICE_AB_SLOT=0
    )

    if "%FLAG_DEVICE_AB_SLOT%" == "0" (
        set SLOT_SUFFIX=
    )

    if "%FLAG_DEVICE_AB_SLOT%" == "1" (
        set device_current_slot=
        for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% getvar current-slot 2^>^&1 ^| %%awk%% "/current-slot: /{printf $2}"`) do (
            set device_current_slot=%%X
        )

        echo [Debug] Device [!serial_number!] current slot: [!device_current_slot!]
        if "!device_current_slot!" == "" (
            color f6
            echo [Warning] The GPT partition table is damaged. Device current slot is Unknown.
            set FLAG_DEVICE_GPT_DAMAGED=1
            set SLOT_SUFFIX=_a
        ) else (
            set SLOT_SUFFIX=_!device_current_slot!
        )

        REM If there are multiple _, use the last two characters
        if "!SLOT_SUFFIX:~0,2!" == "__" (
            set SLOT_SUFFIX=!SLOT_SUFFIX:~-2!
        )
    )

    set storage_type=
    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% getvar storage-type 2^>^&1 ^| %%grep%% -viE "finished|waiting|Done|OKAY|Sending|failed" ^| %%grep%% -v "\.\.\." ^| %%sed%% -e "s/(bootloader)//g;s/INFO//g" ^| %%awk%% -F":" "{print $2}" ^| %%awk%% "{$1=$1; print}"`) do (
        set storage_type=%%X
    )

    set partition_list=
    if "%storage_type%" == "" (
        call :get_normal_partition_list
        set FLAG_DEVICE_USE_MOT_OEM_FASTBOOT=0
    ) else (
        call :get_oem_partition_list
        set FLAG_DEVICE_USE_MOT_OEM_FASTBOOT=1
    )

    if "%partition_list%" == "" (
        call :view_get_partition_list_failed
        exit /b 1
    )

    REM echo [Debug] Device Partition List:"%partition_list%"

    call :set_device_cpu_type "%partition_list%"

    call :set_parition_flag_generic "%partition_list%"

    if "%FLAG_DEVICE_IS_QCOM%" == "1" (
        echo [Debug] Setup QCOM flags.
        call :set_parition_flag_qcom "!partition_list!"
        goto :end
    )
    if "%FLAG_DEVICE_IS_MTK%" == "1" (
        echo [Debug] Setup MTK flags.
        call :set_parition_flag_mtk "!partition_list!"
        goto :end
    )
    if "%FLAG_DEVICE_IS_SLSI%" == "1" (
        echo [Debug] Setup SLSI flags.
        call :set_parition_flag_slsi "!partition_list!"
        goto :end
    )

    echo [Debug] Device Type is Unknown.

    :end
    set device_current_slot=
    set device_slot_count=
    set partition_list=
    set storage_type=
exit /b 0
::
::
:get_normal_partition_list
    set partition_list=
    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s "%%serial_number%%" getvar all 2^>^&1 ^| %%grep%% -viE "finished|waiting|Done|OKAY|Sending|failed" ^| %%grep%% -v "\.\.\." ^| %%sed%% -e "s/(bootloader)//g;s/INFO//g" ^| %%grep%% "has-slot:" ^| %%awk%% -F":" "{print $2}" ^| %%tr%% '\r\n' " " ^| %%sed%% "s/  / /g" ^| %%awk%% "{$1=$1; print}"`) do (
        set partition_list=%%X
    )
exit /b 0
::
::
:get_oem_partition_list
    set partition_list=
    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s "%%serial_number%%" oem partition 2^>^&1 ^| %%grep%% -viE "finished|waiting|Done|OKAY|Sending|failed" ^| %%grep%% -v "\.\.\." ^| %%sed%% -e "s/(bootloader)//g;s/INFO//g;s/lun0//g"  ^| %%awk%% -F":" "{print $1}" ^| %%tr%% -d '\r\n' ^| %%awk%% "{$1=$1; print}"`) do (
        set partition_list=%%X
    )
exit /b 0
::
::
:set_device_cpu_type
    echo %1 | %grep% -q "fsg"
    if %errorlevel% == 0 (
        echo [Debug] Deivce is QCOM.
        set FLAG_DEVICE_IS_QCOM=1
        exit /b 0
    )

    echo %1 | %grep% -Eq "md_udc|preloader|para|nvdata"
    if %errorlevel% == 0 (
        echo [Debug] Deivce is MTK.
        set FLAG_DEVICE_IS_MTK=1
        exit /b 0
    )

    echo %1 | %grep% -q "ldfw"
    if %errorlevel% == 0 (
        echo [Debug] Deivce is SLSI.
        set FLAG_DEVICE_IS_SLSI=1
        exit /b 0
    )
exit /b 0
::
::
:set_parition_flag_generic
    set FLAG_DEVICE_HAS_LOGO=0
    set FLAG_DEVICE_HAS_BOOT=0
    set FLAG_DEVICE_HAS_INIT_BOOT=0
    set FLAG_DEVICE_HAS_VENDOR_BOOT=0
    set FLAG_DEVICE_HAS_RECOVERY=0
    set FLAG_DEVICE_HAS_PVMFW=0
    set FLAG_DEVICE_HAS_DTB=0
    set FLAG_DEVICE_HAS_DTBO=0
    set FLAG_DEVICE_HAS_VBMETA=0
    set FLAG_DEVICE_HAS_VBMETA_SYSTEM=0
    set FLAG_DEVICE_HAS_SUPER=0
    set FLAG_DEVICE_HAS_SYSTEM=0
    set FLAG_DEVICE_HAS_SYSTEM_EXT=0
    set FLAG_DEVICE_HAS_SYSTEM_DLKM=0
    set FLAG_DEVICE_HAS_VENDOR=0
    set FLAG_DEVICE_HAS_VENDOR_DLKM=0
    set FLAG_DEVICE_HAS_PRODUCT=0
    set FLAG_DEVICE_HAS_ODM=0
    set FLAG_DEVICE_HAS_ODM_DLKM=0
    set FLAG_DEVICE_HAS_OEM=0
    set FLAG_DEVICE_HAS_CARRIER=0
    set FLAG_DEVICE_HAS_METADATA=0
    set FLAG_DEVICE_HAS_MODEM=0
    REM old phone model
    set FLAG_DEVICE_HAS_CACHE=0
    set FLAG_DEVICE_HAS_CUSTOMIZE=0
    set FLAG_DEVICE_HAS_CLOGO=0

    echo %1 | %grep% -wEq "logo%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_LOGO=1
    )
    echo %1 | %grep% -wEq "boot%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_BOOT=1
    )
    echo %1 | %grep% -wEq "init_boot%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_INIT_BOOT=1
    )
    echo %1 | %grep% -wEq "vendor_boot%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_VENDOR_BOOT=1
    )
    echo %1 | %grep% -wEq "recovery%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_RECOVERY=1
    )
    echo %1 | %grep% -wEq "pvmfw%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_PVMFW=1
    )
    echo %1 | %grep% -wEq "dtb%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_DTB=1
    )
    echo %1 | %grep% -wEq "dtbo%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_DTBO=1
    )
    echo %1 | %grep% -wEq "vbmeta%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_VBMETA=1
    )
    echo %1 | %grep% -wEq "vbmeta_system%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_VBMETA_SYSTEM=1
    )
    echo %1 | %grep% -wEq "super"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_SUPER=1
    )
    echo %1 | %grep% -wEq "system%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_SYSTEM=1
    )
    echo %1 | %grep% -wEq "system_ext%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_SYSTEM_EXT=1
    )
    echo %1 | %grep% -wEq "system_dlkm%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_SYSTEM_DLKM=1
    )
    echo %1 | %grep% -wEq "vendor%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_VENDOR=1
    )
    echo %1 | %grep% -wEq "vendor_dlkm%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_VENDOR_DLKM=1
    )
    echo %1 | %grep% -wEq "product%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_PRODUCT=1
    )
    echo %1 | %grep% -wEq "odm%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_ODM=1
    )
    echo %1 | %grep% -wEq "odm_dlkm%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_ODM_DLKM=1
    )
    echo %1 | %grep% -wEq "oem%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_OEM=1
    )
    echo %1 | %grep% -wEq "carrier"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_CARRIER=1
    )
    echo %1 | %grep% -wEq "metadata"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_METADATA=1
    )
    echo %1 | %grep% -wEq "modem%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_MODEM=1
    )
    REM old phone model
    echo %1 | %grep% -wEq "cache"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_CACHE=1
    )
    echo %1 | %grep% -wEq "customize"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_CUSTOMIZE=1
    )
    echo %1 | %grep% -wEq "clogo"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_CLOGO=1
    )
exit /b 0
::
::
:set_parition_flag_qcom
    set FLAG_DEVICE_HAS_DSP=0
    set FLAG_DEVICE_HAS_BLUETOOTH=0
    set FLAG_DEVICE_HAS_FSG=0
    set FLAG_DEVICE_HAS_DDR=0
    set FLAG_DEVICE_HAS_OLDDDR=0
    set FLAG_DEVICE_HAS_MODEMST=0
    set FLAG_DEVICE_HAS_MDM1M9KEFS=0

    echo %1 | %grep% -wEq "desp%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_DSP=1
    )
    echo %1 | %grep% -wEq "bluetooth%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_BLUETOOTH=1
    )
    echo %1 | %grep% -wEq "fsg%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_FSG=1
    )
    echo %1 | %grep% -wEq "ddr"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_DDR=1
    )
    echo %1 | %grep% -wEq "DDR"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_OLDDDR=1
    )
    echo %1 | %grep% -wEq "modemst1"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_MODEMST=1
    )
    echo %1 | %grep% -wEq "mdm1m9kefs1"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_MDM1M9KEFS=1
    )

exit /b 0
::
::
:set_parition_flag_mtk
    set FLAG_DEVICE_HAS_PRELOADER=0
    set FLAG_DEVICE_HAS_LK=0
    set FLAG_DEVICE_HAS_TEE=0
    set FLAG_DEVICE_HAS_MCUPM=0
    set FLAG_DEVICE_HAS_PI_IMG=0
    set FLAG_DEVICE_HAS_SSPM=0
    set FLAG_DEVICE_HAS_NVDATA=0
    set FLAG_DEVICE_HAS_SPMFW=0
    set FLAG_DEVICE_HAS_SCP=0
    set FLAG_DEVICE_HAS_MD1IMG=0
    set FLAG_DEVICE_HAS_MD1IMG2=0
    set FLAG_DEVICE_HAS_DPM=0
    set FLAG_DEVICE_HAS_GZ=0
    set FLAG_DEVICE_HAS_CAM_VPU1=0
    set FLAG_DEVICE_HAS_MCF_OTA=0
    set FLAG_DEVICE_HAS_AUDIO_DSP=0
    set FLAG_DEVICE_HAS_CCU=0
    set FLAG_DEVICE_HAS_VCP=0
    set FLAG_DEVICE_HAS_GPUEB=0
    set FLAG_DEVICE_HAS_APUSYS=0
    set FLAG_DEVICE_HAS_EFUSE=0
    set FLAG_DEVICE_HAS_EFUSE_BACKUP=0
    set FLAG_DEVICE_HAS_CONNSYS_BT=0
    set FLAG_DEVICE_HAS_CONNSYS_GNSS=0
    set FLAG_DEVICE_HAS_CONNSYS_WIFI=0

    echo %1 | %grep% -wEq "preloader"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_PRELOADER=1
    )
    echo %1 | %grep% -wEq "lk%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_LK=1
    )
    echo %1 | %grep% -wEq "tee%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_TEE=1
    )
    echo %1 | %grep% -wEq "mcupm%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_MCUPM=1
    )
    echo %1 | %grep% -wEq "pi_img%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_PI_IMG=1
    )
    echo %1 | %grep% -wEq "sspm%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_SSPM=1
    )
    echo %1 | %grep% -wEq "nvdata"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_NVDATA=1
    )
    echo %1 | %grep% -wEq "spmfw%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_SPMFW=1
    )
    echo %1 | %grep% -wEq "scp%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_SCP=1
    )
    echo %1 | %grep% -wEq "md1img%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_MD1IMG=1
    )
    echo %1 | %grep% -wEq "md1img2%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_MD1IMG2=1
    )
    echo %1 | %grep% -wEq "dpm%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_DPM=1
    )
    echo %1 | %grep% -wEq "gz%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_GZ=1
    )
    echo %1 | %grep% -wEq "cam_vpu1%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_CAM_VPU1=1
    )
    echo %1 | %grep% -wEq "mcf_ota%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_MCF_OTA=1
    )
    echo %1 | %grep% -wEq "audio_dsp%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_AUDIO_DSP=1
    )
    echo %1 | %grep% -wEq "ccu%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_CCU=1
    )
    echo %1 | %grep% -wEq "vcp%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_VCP=1
    )
    echo %1 | %grep% -wEq "gpueb%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_GPUEB=1
    )
    echo %1 | %grep% -wEq "apusys%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_APUSYS=1
    )
    echo %1 | %grep% -wEq "efuse"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_EFUSE=1
    )
    echo %1 | %grep% -wEq "efuseBackup"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_EFUSE_BACKUP=1
    )
    echo %1 | %grep% -wEq "connsys_bt%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_CONNSYS_BT=1
    )
    echo %1 | %grep% -wEq "connsys_gnss%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_CONNSYS_GNSS=1
    )
    echo %1 | %grep% -wEq "connsys_wifi%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_CONNSYS_WIFI=1
    )
exit /b 0
::
::
:set_parition_flag_slsi
    set FLAG_DEVICE_HAS_LDFW=0
    set FLAG_DEVICE_HAS_KEYSTORAGE=0
    set FLAG_DEVICE_HAS_FWBL1=0

    echo %1 | %grep% -wEq "ldfw%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_LDFW=1
    )
    echo %1 | %grep% -wEq "keystorage%SLOT_SUFFIX%"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_KEYSTORAGE=1
    )
    echo %1 | %grep% -wEq "fwbl1"
    if %errorlevel% == 0 (
        set FLAG_DEVICE_HAS_FWBL1=1
    )
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_get_partition_list_failed
    color fc
    echo.
    echo [ش] 豸 [%1] ȡбʧܣ߲ԣ
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo 밴˳
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:tips
    call :view_press_any_key_exit
    pause > nul
::
::
:exit
exit
