@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

@SETLOCAL enabledelayedexpansion

:run_flash_smart_single
color f9
call :view_run_flash_smart_single_t
@title %title_name%

    if "%1" == "" (
        call :view_action_opt_empty
        goto :tips
    )
    if not exist "%FLAG_TARGET_FILE%" (
        call :view_img_not_exist
        goto :tips
    )
    set /A failure_count=0

    call "%~dp0get_partition_table.cmd"

    if "%1" == "1" call :do_boot_recovery_onetime && goto :end_do_flash_smart_action
    if "%1" == "2" call :do_direct_flash_recovery && goto :end_do_flash_smart_action
    if "%1" == "3" call :do_flash_others_img && goto :end_do_flash_smart_action
    if "%1" == "4" call :do_flash_boot_img && goto :end_do_flash_smart_action

    :end_do_flash_smart_action
    if %errorlevel% == 1 (
        set /A failure_count+=1
    )

    if %failure_count% == 0 ( color f2 )

    call :view_action_done_footer %serial_number% %failure_count%

    if "%DEVICE_COUNT%" NEQ "1" (
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

exit /b 0
::
::
:do_boot_recovery_onetime
call :view_do_boot_recovery_onetime_t
@title %title_name%
    set img_file=%FLAG_TARGET_FILE%
    set img_name=RECOVERY
    call :view_boot_recovery_title
    %fastboot% -s %serial_number% boot %img_file%
    if %errorlevel% == 1 (
        call :view_boot_image_failed !img_name!
        exit /b 1
    )
exit /b 0
::
::
:do_direct_flash_recovery
call :view_do_direct_flash_recovery_t
@title %title_name%
    if "%FLAG_DEVICE_HAS_RECOVERY%" == "1" (
        set img_file=!FLAG_TARGET_FILE!
        set img_name=RECOVERY
        set pt_name=recovery!SLOT_SUFFIX!
        call :view_flash_image_title !img_name!
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            call :view_flash_image_failed !img_name!
            exit /b 1
        )
    ) else (
        call :view_partition_not_exist !img_name!
        exit /b 1
    )
exit /b 0
::
::
:do_flash_boot_img
call :view_do_flash_boot_img_t
@title %title_name%
    set img_file=%FLAG_TARGET_FILE%
    set img_name=BOOT
    set pt_name=boot%SLOT_SUFFIX%
    call :view_flash_image_title %img_name%
    %fastboot% -s %serial_number% flash %pt_name% %img_file%
    if %errorlevel% == 1 (
        call :view_flash_image_failed !img_name!
        exit /b 1
    )
exit /b 0
::
::
:do_flash_others_img
call :do_flash_others_img_t
@title %title_name%
    set pt_name=

    if "%FLAG_TARGET_FILE_NAME%" == "gpt.bin" ( set "pt_name=partition" )
    if "%FLAG_TARGET_FILE_NAME%" == "motoboot.img" ( set "pt_name=motoboot" )
    if "%FLAG_TARGET_FILE_NAME%" == "bootloader.img" ( set "pt_name=bootloader" )
    if "%FLAG_TARGET_FILE_NAME%" == "logo.bin" ( set "pt_name=logo!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "logo.img" ( set "pt_name=logo!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "vbmeta.img" ( set "pt_name=vbmeta!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "vbmeta_system.img" ( set "pt_name=vbmeta_system!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "boot.img" ( set "pt_name=boot!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "init_boot.img" ( set "pt_name=init_boot!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "vendor_boot.img" ( set "pt_name=vendor_boot!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "dtb.img" ( set "pt_name=dtb!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "dtbo.img" ( set "pt_name=dtbo!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "adspso.bin" ( set "pt_name=dsp!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "dspso.bin" ( set "pt_name=dsp!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "BTFM.bin" ( set "pt_name=bluetooth!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "radio.img" ( set "pt_name=radio" )
    if "%FLAG_TARGET_FILE_NAME%" == "NON-HLOS.bin" ( set "pt_name=modem!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "fsg.mbn" ( set "pt_name=fsg!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "super.img" ( set "pt_name=super" )
    if "%FLAG_TARGET_FILE_NAME%" == "system.img" ( set "pt_name=system!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "vendor.img" ( set "pt_name=vendor!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "oem.img" ( set "pt_name=oem!SLOT_SUFFIX!" )
    if "%FLAG_TARGET_FILE_NAME%" == "product.img" ( set "pt_name=product!SLOT_SUFFIX!" )

    if "%pt_name%" == "" (
        REM can't match any image
        call :not_a_flash_file_error !FLAG_TARGET_FILE_NAME!
        exit /b 1
    )

    call :view_flash_image_title %FLAG_TARGET_FILE_NAME%
    %fastboot% -s %serial_number% flash %pt_name% %FLAG_TARGET_FILE%
    if %errorlevel% == 1 (
        call :view_flash_image_failed !FLAG_TARGET_FILE_NAME!
        exit /b 1
    )

exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_action_opt_empty
    color fc
    echo.
    echo [ش] ѡΪգ
exit /b 0
::
:view_img_not_exist
    color fc
    echo.
    echo [ش] ļڣ
exit /b 0
::
:view_run_flash_smart_single_t
    set title_name=%title% %version% - ˢ [%serial_number%]
exit /b 0
::
:view_do_boot_recovery_onetime_t
    set title_name=%title% %version% - һ RECOVERY  [%serial_number%]
exit /b 0
::
:view_do_direct_flash_recovery_t
    set title_name=%title% %version% - ˢ RECOVERY  [%serial_number%]
exit /b 0
::
:view_do_flash_boot_img_t
    set title_name=%title% %version% - ˢ BOOT  %FLAG_TARGET_FILE_NAME% [%serial_number%]
exit /b 0
::
:do_flash_others_img_t
    set title_name=%title% %version% - ˢд %FLAG_TARGET_FILE_NAME% [%serial_number%]
exit /b 0
::
:view_boot_recovery_title
    echo.
    echo ------ һ RECOVERY  ------
exit /b 0
::
:view_boot_image_failed
    color fc
    echo ------------------------------
    echo [] fastboot  %1 ʧܣ
    echo ------------------------------
exit /b 0
::
:view_flash_image_title
    echo.
    echo ------ ˢ %1  ------
exit /b 0
::
:view_flash_image_failed
    color fc
    echo ------------------------------
    echo [] fastboot ˢ %1 ʧܣ
    echo ------------------------------
exit /b 0
::
:view_partition_not_exist
    color fc
    echo.
    echo [ش] 豸 %1 飡
exit /b 0
::
:not_a_flash_file_error
    color f6
    echo.
    echo [] %1 òƲһˢľļ
exit /b 0
::
:view_action_done_footer
    echo.
    echo 豸 [%1] ɡ %2 
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo 밴˳
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:tips
    call :view_press_any_key_exit
    pause > nul
::
::
:exit
exit
